#!/bin/ash

alias debug=${DEBUG:-:}

# allow env to override nvram
nvram () {
  case $1 in
    get) eval "echo \${NVRAM_$2:-\$(command nvram get $2)}";;
    *) command nvram $*;;
  esac
}
. /etc/nvram.overrides

# valid interface?
if_valid () {
  ip link show dev "$1" >&- 2>&- ||
  [ "${1%%[0-9]}" = "br" ] ||
  {
    [ "${1%%[0-9]}" = "vlan" ] && ( 
      i=${1#vlan}
      hwname=$(nvram get vlan${i}hwname)
      hwaddr=$(nvram get ${hwname}macaddr)
      [ -z "$hwaddr" ] && return 1

      vif=$(ip -o link show | awk '/^[0-9]+:[ \t]eth.*'$hwaddr'/ {sub(":$","",$2); print $2; exit}' IGNORECASE=1)
      debug "# vlan$i => $vif"

      $DEBUG ip link set dev $vif up
      $DEBUG vconfig add $vif $i 2>&-
    )
  } ||
  { echo -e "# $1 ignored: can't find/create"; false; }
}
