#!/bin/sh

VERSION=1.1.4

# To implement this cgi on your web server, copy this
# file to the cgi-bin directory and chmod +x. Unpack
# all language kit files (-de, -en, -es, -fr) to the
# cgi-bin dir also which will produce 4 subdirs here:
#
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-de
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-en
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-es
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-fr
#
# See ./gen-openwrt for more details.

unescape()
{
  echo $1|awk '
  BEGIN {
    hextab["0"]=0; hextab["1"]=1;
    hextab["2"]=2; hextab["3"]=3;
    hextab["4"]=4; hextab["5"]=5;
    hextab["6"]=6; hextab["7"]=7;
    hextab["8"]=8; hextab["9"]=9;
    hextab["A"]=hextab["a"]=10;
    hextab["B"]=hextab["b"]=11;
    hextab["C"]=hextab["c"]=12;
    hextab["D"]=hextab["d"]=13;
    hextab["E"]=hextab["e"]=14;
    hextab["F"]=hextab["f"]=15;
  }
  {
    decoded="";
    i=1;
    len=length($0);
    while (i<=len) {
      c=substr($0, i, 1);
      if (c=="%") {
        if (i+2<=len) {
          c1=substr($0, i+1, 1);
          c2=substr($0, i+2, 1);
          if (hextab[c1]==""||hextab[c2]=="") {
            print "WARNING: invalid hex encoding: %" c1 c2|"cat>&2";
          }
          else {
            code=0+hextab[c1]*16+hextab[c2]+0;
            c=sprintf("%c", code);
            i=i+2;
          }
        }
        else {
          print "WARNING: invalid % encoding: " substr($0, i, len-i);
        }
      }
      else if (c=="+") {
        c=" ";
      }
      decoded=decoded c;
      ++i;
    }
    print decoded;
  }'
}

if [ "$REQUEST_METHOD" = "POST" ]; then
  read QUERY_STRING
fi
if [ -z "$QUERY_STRING" ]; then
  cat <<EOF
Content-type: text/html

<HTML>
  <HEAD><TITLE></TITLE>
  </HEAD>
  <BODY>
    <FORM ACTION="ff.cgi"><TABLE BORDER="1"><TR><TD>lang:</TD><TD><SELECT NAME="lang" SIZE="1">
        <OPTION VALUE="de">de</OPTION>
        <OPTION VALUE="en">en</OPTION>
        <OPTION VALUE="es">es</OPTION>
        <OPTION VALUE="fr">fr</OPTION>
      </SELECT></TD>
      </TR><TR><TD>type: </TD><TD><SELECT NAME="type" SIZE="1">
        <OPTION VALUE="g">g</OPTION>
        <OPTION VALUE="gs">gs</OPTION>
        <OPTION VALUE="gs40">gs40</OPTION>
        <OPTION VALUE="g3g">g3g</OPTION>
        <OPTION VALUE="a">a</OPTION>
        <OPTION VALUE="moto">moto</OPTION>
        <OPTION VALUE="se505">se505</OPTION>
        <OPTION VALUE="trx">trx</OPTION></SELECT></TD>
      </TR><TR><TD>addr: </TD><TD><INPUT NAME="addr"></TD>
      </TR><TR><TD>mask: </TD><TD><INPUT NAME="mask" VALUE="255.0.0.0"></TD>
      </TR><TR><TD>ssid: </TD><TD><INPUT NAME="ssid" VALUE="olsr.freifunk.net"></TD>
      </TR><TR><TD>chan: </TD><TD><INPUT NAME="chan" VALUE="10"></TD>
      </TR><TR><TD>frag: </TD><TD><INPUT NAME="frag" VALUE="512"></TD>
      </TR><TR><TD>rts: </TD><TD><INPUT NAME="rts" VALUE="250"></TD>
      </TR><TR><TD>antdiv:</TD><TD><SELECT NAME="antdiv" SIZE="1">
        <OPTION VALUE="0">Ant A</OPTION>
        <OPTION VALUE="1" SELECTED="SELECTED">Ant B</OPTION>
        <OPTION VALUE="-1">Auto</OPTION>
      </SELECT></TD>
      </TR><TR><TD>hostname: </TD><TD><INPUT NAME="hostname" VALUE="250"></TD>
      </TR><TR><TD COLSPAN="2"><INPUT TYPE="SUBMIT"> Dauer: 20 Sek.!</TD>
      </TR>
    </TABLE></FORM>
  </BODY>
</HTML>
EOF
else
  eval $(echo "$QUERY_STRING"|awk -F'&' '{for(i=1;i<=NF;i++){print $i}}')
  case "$lang" in
    de|en|fr|es)
      echo "Content-type: application/octet-stream"
      case "$type" in
        g|gs|gs40|g3g|moto|se505)
          echo "Content-Disposition: attachment; filename=\"openwrt-$type-freifunk-$VERSION-$lang-$addr.bin\""
        ;;
        a)
          echo "Content-Disposition: attachment; filename=\"openwrt-allnet-freifunk-$VERSION-$lang-$addr.bin\""
        ;;
        trx)
          echo "Content-Disposition: attachment; filename=\"openwrt-freifunk-$VERSION-$lang-$addr.trx\""
        ;;
      esac
      echo
      ${0%/*}/freifunk-openwrt-kit-$VERSION-$lang/gen-openwrt "$type" "$addr" "$mask" "$chan" "$ssid" "$frag" "$rts" "$antdiv" "$hostname"
    ;;
    *)
      echo "Content-type: text/plain"
      echo
      echo "H!?"
    ;;
  esac
fi
